# createUserFolders.py - reads all users from mailstore, then creates
#                        subfolders in rootpath, that are named like
#                        the users,
#                        this is useful when using eml/pst/mbox bulk import
#                        first create directories with this function,
#                        then fill them, then archive

# Copyright (c) 2012,2013 MailStore Software GmbH
# 
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# MailStore Management API connection settings
USER = "admin"
PASSWORD = "admin"
HOST = "localhost"
PORT = 8463

#where should the folders be created in
rootpath="c:\mailstoreimport"

################### DON'T CHANGE ANYTHING BELOW THIS LINE ###################
import mailstoreapi
import os

api = mailstoreapi.ManagementAPI(USER,PASSWORD,HOST,PORT)

folders = [folder["userName"] for folder in api.GetUserList()]

successcount = 0

if input("{0} folder(s) will be created in {1}{2}Continue [y/N]".format(len(folders), rootpath, os.linesep)) in ["y","Y","z","Z"]:
    for folder in folders:
        resultpath = os.path.join(rootpath,folder)
        print("creating {0}   ".format(resultpath),end='')     
        try:
            os.makedirs(resultpath)
        except WindowsError as e:
            print("FAILED")
            print("WindowsError {0}".format(e))
        else:
            print("SUCCESS")
            successcount += 1
print("{0} of {1} folders were created in {2}".format(successcount,len(folders),rootpath))


